'use strict'

const test = require('tape')
const fs = require('fs')

const mock = require('./mocks/mock')()
mock.on('ready', runTests)

const configFile = __dirname + '/' + '.nsolid-proxyrc'

function runTests () {
  // get port from mock & write out test .nsolid-proxyrc
  let config = {
    registry: '127.0.0.1:' + mock.etcdPort,
    port: 0,
    denied: ['foo'],
    broadcast_approved: [
      'ping'
    ]
  }

  fs.writeFileSync(configFile, JSON.stringify(config, null, 2))

  // TODO:
  // start proxy w/ alternate config specifying random port
  // test listener
  //   test ls and '*' events
  // test configs
  // test graceful shutdown

  test('teardown', function (t) {
    // This sucks because you can't `test.only`
    // but tape doesn't have a teardown facility
    fs.unlinkSync(configFile)
    mock.stop()
    t.end()
  })
}
