var http = require('http')
var https = require('https')

var basicTests = require('./basic-tests')
var badEndpointTests = require('./bad-endpoint-tests')

// test APIs taking endpoints, passing in ones which should error
badEndpointTests.run(null)
badEndpointTests.run({ foo: 1 })
badEndpointTests.run('')

// run tests passing in:
// - http or https module to use for server
// - url prefix - none|http://|https:// to use on client uri parm
// - prefix for the name of the test

// specifying no protocol on client == using http://
basicTests.run(http, '', 'no protocol')
basicTests.run(http, 'http://', 'http protocol')
basicTests.run(https, 'https://', 'https protocol')
